class EnergyParticle {
	constructor(game, texture, map, x, y){
		this.game = game;
		
		// Rendering
		this.layer = "background";
		this.texture = texture;
		this.map = map;
		
		// Scale
		this.scale = 1;
		this.size = this.scale * 5;
		this.originalSize = this.size;
		
		// Physics
		this.x = x;
		this.y = y;
		this.r = 360 * Math.random();
		this.speed = 13;
		
		// Energy Particle
		this.maxLife = Math.random() * 2;
		this.life = this.maxLife;
	}
	
	
	update(delta){
		// Move particle in a set direction
		var speed = this.speed;
		this.x += delta * speed * Math.sin(this.r/180*Math.PI);
		this.y += delta * speed * -Math.cos(this.r/180*Math.PI);
		
		// Move particle in a random direction
		speed = this.speed;
		this.x += delta * speed * (Math.random() * 2 - 1);
		this.y += delta * speed * (Math.random() * 2 - 1);
		
		this.size = this.life/this.maxLife * this.originalSize;
		
		return this.life -= delta;
	}
	
	
	draw(context, textures, atlas){
		var texture = this.texture,
			map = this.map;
		
		context.drawImage(texture, map[0], map[1], map[2], map[3], this.x - this.size/2, this.y - this.size/2, this.size, this.size);
	}
}
